"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getIp = getIp;
function getIp(req) {
    let ip;
    if ('_remoteAddress' in req && typeof req._remoteAddress === 'string') {
        ip = req._remoteAddress;
    }
    else if ('socket' in req &&
        typeof req.socket === 'object' &&
        req.socket !== null &&
        'remoteAddress' in req.socket &&
        typeof req.socket.remoteAddress === 'string') {
        ip = req.socket.remoteAddress;
    }
    else if ('request_context' in req &&
        typeof req.request_context === 'object' &&
        req.request_context !== null &&
        'ip_address' in req.request_context &&
        typeof req.request_context.ip_address === 'string') {
        ip = req.request_context.ip_address;
    }
    else if ('headers' in req &&
        typeof req.headers === 'object' &&
        req.headers !== null &&
        'x-forwarded-for' in req.headers &&
        typeof req.headers['x-forwarded-for'] === 'string') {
        ip = req.headers['x-forwarded-for'];
    }
    else {
        ip = 'unknown';
    }
    return ip;
}
//# sourceMappingURL=get-ip.js.map